%This function is for Dijkstra
function [count_r,ri_tj1,flag,sum_cost_primal,sum_cost_after,P_kill_D1]=relaxation(J_amount,N_extension,cij,ri_tj,ri_tj_primal,P_kill_my0)

M=J_amount;
N=N_extension;
flag=0;
Path=[];
P_kill_D1=P_kill_my0;

ui=zeros(1,M);
vj=zeros(1,N);
cij_r=zeros(M,N);

sum_cost_primal=0;
for i=1:M
    ui(i)=cij(i,ri_tj(i));
    cij_r(i,:)=cij(i,:)-ui(i)-vj;
    sum_cost_primal=sum_cost_primal+cij(i,ri_tj(i));    
end
sum_cost_after=sum_cost_primal;
cij_temp=cij_r;  

iterate_limit=1000;  

[~,r0]=min(min(cij_r,[],2));
r1=r0;

v_d=Inf*ones(1,M);
v_d(r0)=0;
v_pai=zeros(1,M);  
state=0; 
visited=zeros(1,M); 
visited(r0)=1;

parent=zeros(1,M);
parent(r0)=1;

count_r=0;
flag_found=0;

while state~=2 && iterate_limit>0
    iterate_limit=iterate_limit-1;
 
    [r2,state,flag_state,v_d,v_pai,visited,count_r,CL]=robot1(cij_r,ri_tj,r0,r0,v_d,v_pai,visited,state,count_r);  
    
    if flag_state
        [B,I]=sort(CL,'ascend');
        [~,col]=find(B<0);        
        for i=1:length(col)
            IDm=I(i); 
            v_pai(r0)=IDm;
            ri_tj_temp=ri_tj;
            r3=v_pai(r0);   
            Path=r3;
            v_i=r3; 
            Path_end=ri_tj_temp(r3);  
            while v_i~=r0  
                ri_tj_temp(v_i)=ri_tj_temp(v_pai(v_i));
                Path=[v_pai(v_i),Path];       
                v_i=v_pai(v_i);        
            end           
            ri_tj_temp(r0)=Path_end;
            T_sur_temp=ones(1,N);
            for j=1:M
                T_sur_temp(ri_tj_primal(ri_tj_temp(j)))=T_sur_temp(ri_tj_primal(ri_tj_temp(j)))*cij(j,ri_tj_temp(j));
            end 
            P_kill_update=0;
            for j=1:N
                P_kill_update=P_kill_update+1-T_sur_temp(j);       
            end
            
            if P_kill_update>P_kill_my0
                ri_tj=ri_tj_temp;
                P_kill_D1=P_kill_update;
                sum_cost_after=0;
                for j=1:M
                    sum_cost_after=sum_cost_after+cij(j,ri_tj(j));    
                end
                flag_found=1;
                break;              
            end            
        end
        if flag_found
           break;
        else
           flag_state=0;
        end
    end
    
    if state==0
        r1=r2;    
        [r2,~,~,v_d,v_pai,visited,count_r,~]=robot1(cij_r,ri_tj,r1,r0,v_d,v_pai,visited,state,count_r);           
    end
    if state==1   
       
        P=find(parent==0); 
        if ~isempty(P)          
           cij_temp(r0,:)=999;
           [~,r0]=min(min(cij_temp,[],2));
           parent(r0)=1;          
        else
            flag=1;
            break;
        end
        v_d=Inf*ones(1,M);
        v_d(r0)=0;
        v_pai=zeros(1,M);  
        state=0; 
        visited=zeros(1,M); 
        visited(r0)=1;       
    end 
    count_r=count_r+1;
end
ri_tj1=ri_tj;
end