clc
clear

M=120;
N=110;
test_count=0;
test_all=1;

loop_limit=280;
fx_AB1_data=zeros(test_all,loop_limit);
fx_my_data=zeros(test_all,loop_limit);
Hybrid_data=zeros(test_all,loop_limit);
runtime0_data=zeros(test_all,loop_limit);
runtime1_data=zeros(test_all,loop_limit);
runtime2_data=zeros(test_all,loop_limit);
round1=zeros(test_all,1);
round2=zeros(test_all,1);
round3=zeros(test_all,1);

tl1=1e-3;
tl2=0.02*120/M;

dam_val1=zeros(test_all,1);
dam_val2=zeros(test_all,1);
dam_val3=zeros(test_all,1);
ttoal1=zeros(test_all,1);
ttoal2=zeros(test_all,1);
ttoal3=zeros(test_all,1);

while test_count<test_all
    test_count=test_count+1;
    Aij0=rand(M,N);
    ri_tj_primal=[];
    for i=1:ceil(M/N)
        if i<ceil(M/N)
            ri_tj_primal=[ri_tj_primal,1:N];
        else
            ri_tj_primal=[ri_tj_primal,1:M-(i-1)*N];
        end
    end
    ri_tj0=1:M;
    cij=zeros(M,M);
    for i=1:M
        for j=1:M
            cij(i,j)=Aij0(i,ri_tj_primal(j));
        end
    end
    cij=1-cij; %transfer from the survival probability to the kill probability
    %calculate the survival probability of the target
    T_sur=ones(1,N);  
    for i=1:M
        T_sur(ri_tj_primal(ri_tj0(i)))=T_sur(ri_tj_primal(ri_tj0(i)))*cij(i,ri_tj0(i));
    end
    T_kill=1-T_sur;
    P_kill0=0;
    for i=1:N
        P_kill0=P_kill0+T_kill(i);
    end
    neighbor=ones(M);
    % AB1
    [ri_tj_AB,fx_AB1,sum_AB1,runtime]=AB1(Aij0,neighbor,P_kill0);
    
    if ~isempty(fx_AB1)
        if length(fx_AB1)<50
            fx_AB1_data(test_count,1:length(fx_AB1))=fx_AB1;
            fx_AB1_data(test_count,(length(fx_AB1)+1):50)=fx_AB1(length(fx_AB1))*ones(1,50-length(fx_AB1));
            runtime0_data(test_count,1:length(runtime))=runtime;
            runtime0_data(test_count,(length(runtime)+1):50)=runtime(length(runtime))*ones(1,50-length(runtime));
        else
            fx_AB1_data(test_count,:)=fx_AB1(1:50);
            runtime0_data(test_count,:)=runtime(1:50);
        end   
    end
    round1(test_count)=length(fx_AB1);
    dam_val1(test_count)=fx_AB1(round1(test_count));
    ttoal1(test_count)=sum(runtime0_data(1:round1(test_count)-1));
    
   %DWLLC
    flag1=0;
    count_my1=1;
    loop1=loop_limit;   
    sum_my=[];
    fx_my=[];
    time_my=[];
    ri_tj_my=ri_tj0;
    P_kill_my0=P_kill0;
        temp_count=0;
        rd1=0;
    while flag1==0 && loop1>0
        loop1=loop1-1;
        t1=clock;
        [count_my,ri_tj_my1,flag1,sum_cost_primal,sum_cost_after,P_kill_my1]=mymethod(M,M,cij,ri_tj_my,ri_tj_primal,P_kill_my0);
        t2=clock;
        time_temp=etime(t2,t1); 
        if time_temp<tl1
            time_temp=tl2;
        end
        if P_kill_my1-P_kill_my0==0
            temp_count=temp_count+1;
        end
        if temp_count<=2
            rd1=loop_limit-loop1;
        end
        if flag1
            fx_my=[fx_my,P_kill_my1];
            time_my=[time_my,time_temp];
            break;
        end          
        fx_my=[fx_my,P_kill_my0];
        time_my=[time_my,time_temp];        
        ri_tj_my=ri_tj_my1;
        P_kill_my0=P_kill_my1;
        count_my1=count_my;
    end
    round2(test_count)=loop_limit-loop1;
    dam_val2(test_count)=fx_my(round2(test_count));
    ttoal2(test_count)=sum(time_my(1:rd1-1));
    
    if ~isempty(fx_my)
    if length(fx_my)<loop_limit
        fx_my_data(test_count,1:length(fx_my))=fx_my;
        fx_my_data(test_count,(length(fx_my)+1):loop_limit)=fx_my(length(fx_my))*ones(1,loop_limit-length(fx_my));
        runtime1_data(test_count,1:length(time_my))=time_my;
        runtime1_data(test_count,(length(time_my)+1):loop_limit)=time_my(length(time_my))*ones(1,loop_limit-length(time_my));
    else
        fx_my_data(test_count,:)=fx_my(1:loop_limit);
        runtime1_data(test_count,:)=time_my(1:loop_limit);
    end
    end
    
    %hybrid
    cij=zeros(M,M);
    [row,~]=size(ri_tj_AB);
    ri_tj_AB1=ri_tj_AB(row,:);
    for i=1:M
        for j=1:M
            cij(i,j)=Aij0(i,ri_tj_AB1(j));
        end
    end
    cij=1-cij;
    T_sur=ones(1,N); 
    for i=1:M
        T_sur(ri_tj_AB1(ri_tj0(i)))=T_sur(ri_tj_AB1(ri_tj0(i)))*cij(i,ri_tj0(i));
    end
    T_kill=1-T_sur;
    P_kill0=0;
    for i=1:N
        P_kill0=P_kill0+T_kill(i);
    end
    flag1=0;
    loop1=loop_limit;   
    sum_hy=[];
    fx_hy=[];
    time_hy=[];
    ri_tj_hy=ri_tj0;
    P_kill_hy0=P_kill0;
        temp_count=0;
        rd2=0;
    while flag1==0 && loop1>0
        loop1=loop1-1;
        t1=clock;
        [~,ri_tj_hy1,flag1,sum_cost_primal,sum_cost_after,P_kill_hy1]=mymethod(M,M,cij,ri_tj_hy,ri_tj_AB1,P_kill_hy0);
        t2=clock;
        time_temp=etime(t2,t1);
        if time_temp<tl1
            time_temp=tl2;
        end
        if P_kill_hy1-P_kill_hy0==0
            temp_count=temp_count+1;
        end
        if temp_count<=2
            rd2=loop_limit-loop1;
        end
        if flag1
            fx_hy=[fx_hy,P_kill_hy1];
            time_hy=[time_hy,time_temp];
            break;
        end          
        fx_hy=[fx_hy,P_kill_hy0];
        time_hy=[time_hy,time_temp];
        ri_tj_hy=ri_tj_hy1;
        P_kill_hy0=P_kill_hy1;
    end
    round3(test_count)=length(fx_AB1)+loop_limit-loop1;
    dam_val3(test_count)=fx_hy(length(fx_hy));
    ttoal3(test_count)=ttoal1(test_count)+sum(time_hy(1:rd2-1));

    if ~isempty(fx_AB1) && ~isempty(fx_hy)
       if (length(fx_AB1)+length(fx_hy))<loop_limit
           Hybrid_data(test_count,1:length(fx_AB1))=fx_AB1;
           Hybrid_data(test_count,length(fx_AB1)+1:length(fx_AB1)+length(fx_hy))=fx_hy;
           Hybrid_data(test_count,(length(fx_AB1)+length(fx_hy)+1):loop_limit)=fx_hy(length(fx_hy))*ones(1,loop_limit-length(fx_hy)-length(fx_AB1));
           runtime2_data(test_count,1:length(runtime))=runtime;
           runtime2_data(test_count,length(runtime)+1:length(runtime)+length(time_hy))=time_hy;
           runtime2_data(test_count,(length(runtime)+length(time_hy)+1):loop_limit)=time_hy(length(time_hy))*ones(1,loop_limit-length(time_hy)-length(runtime));
           round3(test_count)=length(fx_AB1)+loop_limit-loop1;
       else
           if length(fx_AB1)<loop_limit
               Hybrid_data(test_count,1:length(fx_AB1))=fx_AB1;
               Hybrid_data(test_count,(length(fx_AB1)+1):loop_limit)=fx_hy(1:loop_limit-length(fx_AB1));
               runtime2_data(test_count,1:length(runtime))=runtime;
               runtime2_data(test_count,(length(runtime)+1):loop_limit)=time_hy(1:loop_limit-length(runtime));
           else
               Hybrid_data(test_count,:)=fx_AB1(1:loop_limit);
               runtime2_data(test_count,:)=runtime(1:loop_limit);
           end
           round3(test_count)=loop_limit;
       end
    end
    
end

% save fx_AB1_data.txt -ascii fx_AB1_data
% save fx_my_data.txt -ascii fx_my_data
% save Hybrid_data.txt -ascii Hybrid_data
% save runtime0_data.txt -ascii runtime0_data
% save runtime1_data.txt -ascii runtime1_data
% save runtime2_data.txt -ascii runtime2_data
% save round1.txt -ascii round1
% save round2.txt -ascii round2
% save round3.txt -ascii round3


fx_AB1_data_mean=mean(fx_AB1_data,1);
fx_my_mean=mean(fx_my_data,1);
Hybrid_data_mean=mean(Hybrid_data,1);
runtime0_data_mean=mean(runtime0_data,1);
runtime1_data_mean=mean(runtime1_data,1);
runtime2_data_mean=mean(runtime2_data,1);
rn1=mean(round1);
rn2=mean(round2);
rn3=mean(round3);

rf1=mean(dam_val1);
rt1=mean(ttoal1);
rf2=mean(dam_val2);
rt2=mean(ttoal2);
rf3=mean(dam_val3);
rt3=mean(ttoal3);
rf1_var=std(dam_val1,1);
rt1_var=std(ttoal1,1);
rf2_var=std(dam_val2,1);
rt2_var=std(ttoal2,1);
rf3_var=std(dam_val3,1);
rt3_var=std(ttoal3,1);
result_data=[rf1,rt1,rf2,rt2,rf3,rt3,rf1_var,rt1_var,rf2_var,rt2_var,rf3_var,rt3_var];
% save result_data.txt -ascii result_data

linewidth=2;
fontsize=20;
t_limit=10*1000;

t2=1:round(runtime2_data_mean(1)*1000);
y2=Hybrid_data_mean(1)*ones(1,length(t2));
for i=2:rn3
    t_temp1=length(t2);
    t_temp2=t_temp1+round(runtime2_data_mean(i)*1000);
    t2=[t2,t_temp1+1:t_temp2];
    y2=[y2,Hybrid_data_mean(i)*ones(1,round(runtime2_data_mean(i)*1000))];
end
plot(t2/1000,y2,'k-','LineWidth',linewidth)

hold on
grid on
t0=1:round(runtime0_data_mean(1)*1000);
y0=fx_AB1_data_mean(1)*ones(1,length(t0));
for i=2:rn1
    t_temp1=length(t0);
    t_temp2=t_temp1+round(runtime0_data_mean(i)*1000);
    t0=[t0,t_temp1+1:t_temp2];
    y0=[y0,fx_AB1_data_mean(i)*ones(1,round(runtime0_data_mean(i)*1000))];
end
plot(t0/1000,y0,'r-','LineWidth',linewidth)

t1=1:round(runtime1_data_mean(1)*1000);
y1=fx_my_mean(1)*ones(1,length(t1));
for i=2:rn2
    t_temp1=length(t1);
    t_temp2=t_temp1+round(runtime1_data_mean(i)*1000);
    t1=[t1,t_temp1+1:t_temp2];
    y1=[y1,fx_my_mean(i)*ones(1,round(runtime1_data_mean(i)*1000))];
end
plot(t1/1000,y1,'g-','LineWidth',linewidth)

legend('Hybrid','AB1','DWLLC')
