%%%AB2
function [assign,fx1,sum1,runtime]=AB2(Aij0,neighbor)
iteration_count=0;  
Aij_primal=Aij0;

[M,N_primal]=size(Aij_primal);
N_extension=N_primal*ceil(M/N_primal);  
P=zeros(M,N_extension); 
P_temp=zeros(M,N_extension);
P_update=P;

P_R_ID=zeros(M,N_extension);  
P_R_ID_update=P_R_ID;
Jt_ago=ones(1,M);  
Jt_after_iteration=ones(1,M);  
Jt_primal=ones(1,M); 

Aij=zeros(M,N_extension);
for i=1:ceil(M/N_primal)
    j_min=(i-1)*N_primal+1;
    j_max=(i-1)*N_primal+N_primal;
    Aij(:,j_min:j_max)=Aij_primal; 
end

kesi=min(min(Aij));
derminate_con=M*N_extension*((max(max(Aij))-min(min(Aij)))/kesi);
if derminate_con==0
    derminate_con=M*N_extension;
end

fx1=[];
sum1=[];
assign=[];
runtime=[];

tl1=1e-4;
tl2=0.02*M/120;

while iteration_count<derminate_con 
    iteration_count=iteration_count+1; 
    t1=clock;
    for i=1:M
       [P_update(i,:),Jt_after_iteration(i),P_R_ID_update(i,:)]=robot1(P,P_R_ID,Aij(i,:),Jt_ago(i),N_extension,i,neighbor);
       Jt_ago(i)=Jt_after_iteration(i);  
    end
    t2=clock;
    time_temp=etime(t2,t1);
    
    if time_temp<tl1
        time_temp=tl2;
    end
    runtime=[runtime,time_temp];
    
    P=P_update;
    P_R_ID=P_R_ID_update;     
  
    if all((P_temp-P)==0)
        break;
    end
    P_temp=P;
   
    sum_temp=0;
    for i=1:M
        Jt_primal(i)=Jt_after_iteration(i)-((ceil(Jt_after_iteration(i)/N_primal)-1)*N_primal);
        sum_temp=sum_temp+Aij(i,Jt_after_iteration(i));
    end
   
    T_sur=ones(1,N_primal);  
    for i=1:M
        T_sur(Jt_primal(i))=T_sur(Jt_primal(i))*(1-Aij0(i,Jt_primal(i)));
    end  
    T_kill=1-T_sur;
    P_kill=0;
    for i=1:N_primal
        P_kill=P_kill+T_kill(i);
    end
    fx1=[fx1,P_kill];
    sum1=[sum1,sum_temp];
    assign=[assign; Jt_primal];
end

end

