%%%this function is embedded in AB1
function [P11,Jt11,W_T_ID11,W_T_SUR11,W_ALLT_SUR11]=robot(P0,W_T_ID0,W_T_SUR0,W_ALLT_SUR0,Jt00,Aij00,ID,~)
[M,N]=size(P0);

P_ago=P0(ID,Jt00);  

for j=1:M
    if j<=N
        P0(ID,j)=max(P0(:,j));
    end
    [W_ALLT_SUR0(ID,j),W_min_ID]=min(W_ALLT_SUR0(:,j));
    W_T_ID0(ID,j)=W_T_ID0(W_min_ID,j);
    W_T_SUR0(ID,j)=W_T_SUR0(W_min_ID,j);
end

if P_ago<P0(ID,Jt00) || W_T_SUR0(ID,ID)==1  
    %calculate the value of the object function
    T_sur=ones(1,N);
    T_sur_trial=ones(1,N);
    for i=1:M
        %calculate the the value of the object function before updating the
        %weapon ID's assigned target.
        T_sur(W_T_ID0(ID,i))=T_sur(W_T_ID0(ID,i))*W_T_SUR0(ID,i);
        %calculate the the value of the object function after removing the
        %weapon ID's assigned target.
        if i~=ID
            T_sur_trial(W_T_ID0(ID,i))=T_sur_trial(W_T_ID0(ID,i))*W_T_SUR0(ID,i);
        end
    end  
    T_sur_sum=W_ALLT_SUR0(ID,ID);
    %calcute the revenue value
    vij=Aij00-P0(ID,:);
    [~,ID_descend]=sort(vij,2,'descend');  
    %update for bidding
    for i=1:1
        J1=ID_descend(i);  
        if i+1<=N
           jk_next=ID_descend(i+1);  
        else
           jk_next=J1; 
        end
        kesi=Aij00(J1);
        %%%update price
        P11=P0(ID,:);
        %calculate the the value of the object function after updating the
        %weapon ID's assigned target.
        T_sur_temp=T_sur_trial(J1)*(1-Aij00(J1));
        T_sur_sum_update=T_sur_sum-T_sur(Jt00)-T_sur(J1)+T_sur_trial(Jt00)+T_sur_temp;
        %if meet the condition below, bid the updated price.
        %notice that here is the error! Since the T_sur_sum is chaging but
        %not decreasing monotonous.
        if T_sur_sum_update<T_sur_sum  
            %update
            P11(J1)=P0(ID,J1)+0.5*(vij(J1)-vij(jk_next))+0.5*kesi;
            Jt11=J1;
            W_T_ID0(ID,ID)=J1;
            W_T_ID11=W_T_ID0(ID,:);
            W_T_SUR0(ID,ID)=1-Aij00(J1);
            W_T_SUR11=W_T_SUR0(ID,:);
            W_ALLT_SUR0(ID,ID)=T_sur_sum_update;
            W_ALLT_SUR11=W_ALLT_SUR0(ID,:);
            break;
        else
            P11=P0(ID,:);
            Jt11=Jt00;
            W_T_ID11=W_T_ID0(ID,:);
            W_T_SUR11=W_T_SUR0(ID,:);
            W_ALLT_SUR11=W_ALLT_SUR0(ID,:);
        end 
    end  
else
    P11=P0(ID,:);
    Jt11=Jt00;
    W_T_ID11=W_T_ID0(ID,:);
    W_T_SUR11=W_T_SUR0(ID,:);
    W_ALLT_SUR11=W_ALLT_SUR0(ID,:);    
end
end

