%DWLLC
function [count_my,ri_tj1,flag,sum_cost_primal,sum_cost_after,P_kill_my1]=mymethod(J_amount,N_extension,cij,ri_tj,ri_tj_primal,P_kill_my0)

M=J_amount;
N=N_extension;
flag=0;
neighbor=ones(M);
Path=[];
P_kill_my1=P_kill_my0;

ui=zeros(1,M);
vj=zeros(1,N);
cij_r=zeros(M,N);

sum_cost_primal=0;
for i=1:M
    ui(i)=cij(i,ri_tj(i));
    cij_r(i,:)=cij(i,:)-ui(i)-vj;
    sum_cost_primal=sum_cost_primal+cij(i,ri_tj(i));    
end
sum_cost_after=sum_cost_primal;
cij_temp=cij_r;  

iterate_limit=1000; 

[~,r0]=min(min(cij_r,[],2));
r1=r0;
v_d=Inf*ones(1,M);
v_d(r0)=0;
v_pai=zeros(1,M);  
v_d_now=Inf*ones(1,M);
v_d_now(r0)=0;
v_pai_now=zeros(1,M);  
v_d_pre=Inf*ones(1,M);
v_d_pre(r0)=0;
v_pai_pre=zeros(1,M);  

state=0; 
visited=zeros(1,M);  
visited(r0)=1;

parent=zeros(1,M);
parent(r0)=1;

count_my=0;
flag_found=0;

while iterate_limit>0
    iterate_limit=iterate_limit-1;
    count_my=count_my+1;
 
    [r2,state,flag_state,v_d,v_pai,visited,CL]=robot6(cij_r,ri_tj,neighbor,r0,r0,v_d_now,v_pai_now,v_d_pre,visited,state);  
    if r1==r0  
       v_d_now=v_d;
       v_pai_now=v_pai; 
    end
    if flag_state==1  %swap loop may be found 
        [B,I]=sort(CL,'ascend');
        [~,col]=find(B<0);        
        for i=1:length(col)
            %find the minimum CL currently
            IDm=I(i); %the ID of the minimum CL currently
            v_pai(r0)=IDm;
            ri_tj_temp=ri_tj;
            r3=v_pai(r0);   
            Path=r3;
            v_i=r3;  
            Path_end=ri_tj_temp(r3);  
            while v_i~=r0  
                ri_tj_temp(v_i)=ri_tj_temp(v_pai(v_i));
                Path=[v_pai(v_i),Path];       
                v_i=v_pai(v_i);        
            end
            %ri_tj_temp is a temporally value after changing along the task
            %swap.
            ri_tj_temp(r0)=Path_end;
            %calculate the new value of object function although it may be
            %temporal
            T_sur_temp=ones(1,N);
            for j=1:M
                T_sur_temp(ri_tj_primal(ri_tj_temp(j)))=T_sur_temp(ri_tj_primal(ri_tj_temp(j)))*cij(j,ri_tj_temp(j));
            end 
            P_kill_update=0;
            for j=1:N
                P_kill_update=P_kill_update+1-T_sur_temp(j);       
            end
            
            if P_kill_update>P_kill_my0
                ri_tj=ri_tj_temp;
                P_kill_my1=P_kill_update;
              
                sum_cost_after=0;
                for j=1:M
                    sum_cost_after=sum_cost_after+cij(j,ri_tj(j));    
                end
                flag_found=1;
                break;              
            end
        end
        if flag_found
            break;
        else
            flag_state=0;
        end
    end
    if state==0
        r1=r2;     
        [r2,state,~,v_d,v_pai,visited,~]=robot6(cij_r,ri_tj,neighbor,r1,r0,v_d_now,v_pai_now,v_d_pre,visited,state); 
        v_d_pre=v_d_now;
        v_pai_pre=v_pai_now;
        v_d_now=v_d;
        v_pai_now=v_pai;            
    end
    if state==3  
        if parent(r2)~=1
            parent(r2)=1;
            r0=r2;
        else
            
            P=find(parent==0); 
            if ~isempty(P)          
               cij_temp(r0,:)=999;
               [~,r0]=min(min(cij_temp,[],2));
               parent(r0)=1;          
            else
                flag=1;
                break;
            end
        end
   
        v_d=Inf*ones(1,M);
        v_d(r0)=0;
        v_pai=zeros(1,M); 
        v_d_now=Inf*ones(1,M);
        v_d_now(r0)=0;
        v_pai_now=zeros(1,M);  
        v_d_pre=Inf*ones(1,M);
        v_d_pre(r0)=0;
        v_pai_pre=zeros(1,M);  
        state=0; 
        visited=zeros(1,M); 
        visited(r0)=1;
        r1=r0;
    end    
    if state==1   
        P=find(parent==0); 
        if ~isempty(P)          
           cij_temp(r0,:)=999;
           [~,r0]=min(min(cij_temp,[],2));
           parent(r0)=1;          
        else
            flag=1;
            break;
        end
        v_d=Inf*ones(1,M);
        v_d(r0)=0;
        v_pai=zeros(1,M);  
        v_d_now=Inf*ones(1,M);
        v_d_now(r0)=0;
        v_pai_now=zeros(1,M);  
        v_d_pre=Inf*ones(1,M);
        v_d_pre(r0)=0;
        v_pai_pre=zeros(1,M);  
        state=0; 
        visited=zeros(1,M);  
        visited(r0)=1; 
        r1=r0;
    end 
end
ri_tj1=ri_tj;
end
